> For the complete documentation index, see [llms.txt](https://docs.fractalworks.io/joule/llms.txt). Markdown versions of documentation pages are available by appending `.md` to page URLs; this page is available as [Markdown](https://docs.fractalworks.io/joule/use-case-examples/telco/basic-analytics.md).

# Basic analytics

***

This example demostrates a basic select aggregate ratio function based upon `IMSI` and `celltower` within the `select` statement.

## Use case configuration

*File: app-geospatialMarketingCampaign.env*

```bash
SOURCEFILE=conf/sources/mobileSimulatedStream.yaml
REFERENCEDATA=conf/sources/mobileReferenceData.yaml
ENGINEFILE=conf/usecases/analytics/mobileEventBasicAnalyticsFunctions.yaml
PUBLISHFILE=conf/publishers/enrichedEventsInfluxdb.yaml
```

Reference data stores can be used to prime the geofences. Change the required yaml file to test this feature in the app.env file.

```bash
ENGINEFILE=conf/usecases/analytics/mobileReferenceData.yaml
```

## Pipeline **configuration**

{% code overflow="wrap" %}

```yaml
processing unit:
  pipeline:
    - tokenizer enricher:
        tokenizers:
          imei : com.fractalworks.streams.examples.telco.enricher.IMEIDecoder
          latlng: com.fractalworks.streams.examples.telco.enricher.LatitudeLongitudeDecoder

    - obfuscation:
        name: piiMasking
        enabled: true
        cloneEvent: false
        fields:
          imsi:
            encryption:
              decrypt: false
              key location: ./keytmp
              aes bit length: 128
              rsa bit length: 2048
              rotate keys: true

    - enricher:
        enrich:
          deviceType:
            key: device
            using: deviceStore

          bundles:
            key: dataBundle
            using: dataBundleStore

        stores:
          dataBundleStore:
            storeName: bundles
            primaryKey: bundleid
            primaryKeyType: java.lang.Integer
            queryByKey: true

          deviceStore:
            storeName: mobiledevices
            primaryKey: tac
            primaryKeyType: java.lang.String

select:
  expression: "imsi, device.manufacturer, device.model, bytesUp, bytesDown, 'byteRatio' bytesUp / bytesDown, celltower, droppedCall, latitude, longitude"

group by:
  - imsi
  - celltower
```

{% endcode %}

## Select statement

```yaml
select:
    expression: "imsi, 
                 device.manufacturer, 
                 device.model, 
                 bytesUp, 
                 bytesDown, 
                 'byteRatio' bytesUp / bytesDown, 
                 celltower, 
                 droppedCall, 
                 latitude, 
                 longitude"
```


---

# Agent Instructions
This documentation is published with GitBook. GitBook is the documentation platform designed so that both humans and AI agents can read, navigate, and reason over technical content effectively. Learn more at gitbook.com.

## Querying This Documentation
If you need additional information that is not directly available in this page, you can query the documentation dynamically by asking a question.

Perform an HTTP GET request on the current page URL with the `ask` query parameter, and the optional `goal` query parameter:

```
GET https://docs.fractalworks.io/joule/use-case-examples/telco/basic-analytics.md?ask=<question>&goal=<endgoal>
```

`ask` is the immediate question: it should be specific, self-contained, and written in natural language.
`goal` is optional and describes the broader end goal you are ultimately trying to accomplish on behalf of the user. GitBook uses it to tailor the answer towards what is most useful for that goal.

The response will contain a direct answer to the question and relevant excerpts and sources from the documentation.

Use this mechanism when the answer is not explicitly present in the current page, you need clarification or additional context, or you want to retrieve related documentation sections.
